local mod, mod_name, oi = Mods.new_mod("chat")
--[[
	Chat:
		This will manage ...
]]--

mod.animation = nil
mod.system = false
mod.update = {}

-- ####################################################################################################################
-- ##### Function #####################################################################################################
-- ####################################################################################################################	
mod.send = function(message)
	if Managers.chat:has_channel(1) then
		mod.system = true
		
		Managers.chat:send_chat_message(1, message)
		
		mod.system = false
	end
end

mod.on_message = function(message)
	-- Check message is command
	if string.sub(message, 1, 1) ~= "/" then
		return true
	end
	
	-- Check action settings
	for _, item in ipairs(mod.update) do
		if 
			"/" .. item[1] == string.sub(message, 1, item[1]:len() + 1) and

			--Check space after command
			not(
				item[1]:len() + 1 < message:len() and
				"/" .. item[1] .. " " ~= string.sub(message, 1, item[1]:len() + 2)
			)
		then
			local arg = {}
			
			-- Build arguments
			table.insert(arg, item[2]) -- File directory
			table.insert(arg, item[3]) -- File name
			
			-- Extract parameter
			if item[1]:len() + 1 < message:len() then
				local para = string.sub(message, item[1]:len()+3, message:len())
				
				table.insert(arg, {para}) -- Parameters
			end
			
			-- Execute
			local status, value = Mods.exec(unpack(arg))
			
			-- Check results
			return false
		end
	end
	
	EchoConsole(Localize("vmf_text_chat_unknown_cmd", message))

	return false
end

mod.get = function(name)
	for _, command in pairs(mod.update) do
		if command[1] == name then
			return command
		end
	end
	return nil
end

mod.add = function(name, folder, script)
	local command = mod.get(name)
	
	if command then
		command = {name, folder, script}
	else
		local command = {name, folder, script}
		mod.update[#mod.update+1] = command
	end
	return true
end
