local mod, mod_name, oi = Mods.new_mod("ModSettings")

mod.widget_settings = {
	HK_SHOTCUTS = {
		["save"] = "vmf_mod_settings_hotkey_keyblock",
		["widget_type"] = "stepper",
		["text"] = Localize("vmf_text_mod_settings_shortcut_text"),
		["tooltip"] = Localize("vmf_text_mod_settings_shortcut_text") .. "\n" .. Localize("vmf_text_mod_settings_shortcut_tooltip"),
		["value_type"] = "boolean",
		["options"] = {
			{text = Localize("vmf_text_core_off"), value = false},
			{text = Localize("vmf_text_core_on"), value = true},
		},
		["default"] = 2,
	},
	HK_FEEDBACK = {
		["save"] = "vmf_mod_settings_hotkey_feedback",
		["widget_type"] = "stepper",
		["text"] = Localize("vmf_text_mod_settings_feedback_text"),
		["tooltip"] = Localize("vmf_text_mod_settings_feedback_text") .. "\n" .. Localize("vmf_text_mod_settings_feedback_tooltip"),
		["value_type"] = "boolean",
		["options"] = {
			{text = Localize("vmf_text_core_off"), value = false},
			{text = Localize("vmf_text_core_on"), value = true},
		},
		["default"] = 1, -- Default first option is enabled. In this case On
	},
	HK_RELOAD = {
		["save"] = "vmf_mod_settings_hotkey_reload",
		["widget_type"] = "keybind",
		["text"] = Localize("vmf_text_mod_settings_reload_text"),
		["default"] = {
			"r",
			oi.key_modifiers.CTRL_SHIFT,
		},
		["exec"] = {"action", "reload"},
	},
}

-- Old code support
ModSettings = mod
ModSettings.SETTINGS = mod.widget_settings

-- ####################################################################################################################
-- ##### Options ######################################################################################################
-- ####################################################################################################################
mod.create_options = function()
	Mods.option_menu:add_item("mod_settings", mod.widget_settings.HK_SHOTCUTS, true)
	Mods.option_menu:add_item("mod_settings", mod.widget_settings.HK_FEEDBACK, true)
	Mods.option_menu:add_item("mod_settings", mod.widget_settings.HK_RELOAD, true)
	
	--Fixes
	--widget_mode.style.tooltip_text.cursor_offset = {-10, 250} -- fix tooltip position
end

-- ####################################################################################################################
-- ##### Start ########################################################################################################
-- ####################################################################################################################
mod.create_options()