local mod, mod_name, oi = Mods.get_mod("keyboard")
--[[
	Patch Keyboard:
		Every time you host/join a new map the key binding needs to be reloaded.
--]]

-- ####################################################################################################################
-- ##### Hook #########################################################################################################
-- ####################################################################################################################
Mods.hook.set(mod_name, "MatchmakingManager.update", function(func, ...)
	func(...)
	
	for _, item in ipairs(mod.update) do
		if mod.pressed(item[1]) then			
			Mods.exec(item[2], item[3], item[4])
		end
	end
	
	return
end)

Mods.hook.set(mod_name, "StateInGameRunning.event_game_started", function(func, ...)
	func(...)
	
	mod.init()
end)

Mods.hook.set(mod_name, "StateInGameRunning.event_game_actually_starts", function(func, ...)
	func(...)
	
	mod.init()
end)

-- ####################################################################################################################
-- ##### Start ########################################################################################################
-- ####################################################################################################################
mod.init()

-- Sync settings
for _, command in pairs(Mods.settings.actions) do
	if type(command[1]) == "table" then
		mod.update[#mod.update+1] = command
	end
end