local mod_name = "OptionsInjector"
--[[
	Author: grasmann
	
	Injects custom options into menus
--]]

local me = OptionsInjector

local get = Application.user_setting
local set = Application.set_user_setting
local save = Application.save_user_settings

Mods.manager._mods["OptionsInjector"] = {
	mod_name = mod_name,
	version = "1.0.0",
}

-- ####################################################################################################################
-- ##### Hooks ########################################################################################################
-- ####################################################################################################################
--[[
	Hook to make sure the ingame ui is loaded because we need a reference
--]]
Mods.hook.set(mod_name, "IngameUI.update", function(func, self, dt, t, ...)
	local oi = OptionsInjector
	oi.init(self.views.options_view)

	if self.views.options_view.selected_settings_list == self.views.options_view.settings_lists.mod_settings then
		oi.dynamic.update()
		oi.widgets.set_offsets()
		oi.widgets.update(self.views.options_view)
	end
	
	func(self, dt, t, ...)
end)
--[[
	Hook to recreate options when ui is recreated
--]]
Mods.hook.set(mod_name, "StateInGameRunning.create_ingame_ui", function(func, self, ingame_ui_context)
	local oi = OptionsInjector
	func(self, ingame_ui_context)
	if oi.initialized then
		oi.initialized = false
	end
end)